View Issue Details

IDProjectCategoryView StatusLast Update
0001089Composrcommandrpublic2020-02-23 15:57
ReporterChris GrahamAssigned ToChris Graham 
Severityfeature 
Status resolvedResolutionfixed 
Product Version 
Fixed in Version 
Summary0001089: Commandr-fs content hooks
DescriptionAdd a new abstract CRUD/REST-style internal content API via Commandr-fs.

Implement this for all the content_meta_aware and resource_meta_aware hooks, adapting the existing hooks to reference the new Commandr-fs for that hook. The content_meta_aware/resource_meta_aware hook must specify whether they are operating on directories (categories) or files (entries). i.e. we don't implement separate Commandr-fs hooks for category and entry types, they are shared by one hook, which handles them as directories and files.

Content-types will be uniquely identified by a URL moniker.

In order to facilitate quick and consistent implementation of the hooks, they will inherit from a superclass which defines some of this functionality automatically.

Our Commandr-fs objects should have the following methods, roughly...

class … extends commandr_fs_cma_bridge
{
    function find_id_by_context($context)
    {
    }

    function find_id_by_name_and_context($name,$context)
    {
    }

    function add($name,$context)
    {
    }

    function delete($id)
    {
    }

    // Most of the following will inherit, so actually will be defined in commandr_fs_cma_bridge

    function set_properties_via_cloning($id,$from_id)
    {
    }

    function set_properties_via_import($id,$file_path)
    {
    }

    function set_property($id,$key,$val)
    {
    }

    function set_content_access($id,$groups)
    {
    }

    function set_content_privileges_from_preset($id,$group_presets,$assume_full_group_coverage=true)
    {
    }

    function set_content_privileges($id,$group_settings,$assume_full_group_coverage =true)
    {
    }

    function set_content_privileges_from_preset__member($id,$member_preset)
    {
    }

    function set_content_privileges__member($id,$privilege,$setting)
    {
    }

    function find_cma_hook()
    {
    }
}

We need a function defined in the existing Composr content API…

function find_commandr_s_hook_for($content_type)
{
}

This allows easy integration of the existing content API, with the more sophisticated CRUD Commandr-fs API.
TagsNo tags attached.
Attach Tags
Time estimation (hours)8
Sponsorship open

Relationships

parent of 0001113 resolvedChris Graham Composr Aggregate Content Types 
parent of 0001139 non-assigned Composr Commandr-fs resource hook - theme images 
parent of 0001138 resolvedChris Graham Composr Commandr-fs resource hook - newsletters 
parent of 0001137 resolvedChris Graham Composr Commandr-fs resource hook - emoticons 
parent of 0001136 resolvedChris Graham Composr Commandr-fs resource hook - filedump 
parent of 0001135 resolvedChris Graham Composr Commandr-fs resource hook - point-store 
parent of 0001134 resolvedChris Graham Composr Commandr-fs resource hook - staff stuff 
parent of 0001133 non-assigned Composr Commandr-fs resource hook - chat messages 
parent of 0001132 non-assigned Composr non-bundled addons Commandr-fs resource hook - billboard 
parent of 0001131 non-assigned Composr Commandr-fs resource hook - warning templates 
parent of 0001130 non-assigned Composr Commandr-fs resource hook - private topic invitations 
parent of 0001129 non-assigned Composr Commandr-fs resource hook - quiz entries 
parent of 0001128 resolvedChris Graham Composr Commandr-fs resource hook - word-filter 
parent of 0001127 resolvedChris Graham Composr Commandr-fs resource hook - HTTPS settings 
parent of 0001126 resolvedChris Graham Composr Commandr-fs resource hook - gathered feedback info 
parent of 0001125 resolvedChris Graham Composr Commandr-fs resource hook - member settings 
parent of 0001124 non-assigned Composr Commandr-fs resource hook - event reminders 
parent of 0001090 resolvedChris Graham Composr WebDav for Commandr-fs 
parent of 0001140 non-assigned Composr non-bundled addons Commandr-fs resource hook - classifieds 
parent of 0001141 non-assigned Composr non-bundled addons Commandr-fs resource hook - gifts 
parent of 0001142 non-assigned Composr non-bundled addons Commandr-fs resource hook - diseases 
parent of 0001143 non-assigned Composr non-bundled addons Commandr-fs resource hook - activities 
parent of 0001145 non-assigned Composr non-bundled addons Commandr-fs resource hook - booking 
parent of 0001146 non-assigned Composr non-bundled addons Commandr-fs resource hook - workflow 
parent of 0001147 resolvedChris Graham Composr Commandr-fs resource hook - redirects 
parent of 0001151 resolvedChris Graham Composr Commandr-fs resource hook - welcome emails 
related to 0001123 non-assigned Composr Implement CMIS 
Not all the children of this issue are yet resolved or closed.

Activities

Chris Graham

2013-04-11 00:22

administrator   ~0001354

While everything discussed here is done, there's some testing and detail work to be done for this, which has become Composr's new "Resource-FS" system. This is going to be finished in the next few days, but I'll put down here for reference...

 Do a search of a Resource-FS hook's structure if it fails to look up a label, to confirm it really is missing - but only if we don't have too much of that content type (i.e. a safeguard)
 Unit tests for resource-fs, life-cycle each resource type with lots of asserts (partially done, 'delete' ops not yet fully passing)
 Unit tests for aggregate content types (ACT), life-cycling
 Test ACT UI
 Test ACT in detail
 "Explicit move flag" used for Wiki+ page path, as currently prevents multi-categorisation of pages
 Make sure GUIDs are explicitly set/specified for the resources auto-created when a match failed (currently it's not done)
 Implement _folder.xml

Chris Graham

2013-04-17 13:16

administrator   ~0001366

^ all done

Issue History

Date Modified Username Field Change